OpenTTD

Data Structures | Functions | Variables
waypoint_sl.cpp File Reference

Code handling saving and loading of waypoints. More...

`#include "../stdafx.h"`
`#include "../waypoint_base.h"`
`#include "../newgrf_station.h"`
`#include "../vehicle_base.h"`
`#include "../town.h"`
`#include "../newgrf.h"`
`#include "table/strings.h"`
`#include "saveload_internal.h"`
`#include "../safeguards.h"`

Go to the source code of this file.

## Data Structures
struct | OldWaypoint
| Helper structure to convert from the old waypoint system. More...

## Functions
static void | UpdateWaypointOrder (Order *o)
| Update the waypoint orders to get the new waypoint ID. More...
void | MoveWaypointsToBaseStations ()
| Perform all steps to upgrade from the old waypoints to the new version that uses station. More...
static void | Load_WAYP ()
static void | Ptrs_WAYP ()

## Variables
static SmallVector< OldWaypoint, 16 > | _old_waypoints
| Temporary array with old waypoints. More...
static const SaveLoad | _old_waypoint_desc []
const ChunkHandler | _waypoint_chunk_handlers []

## Detailed Description

Code handling saving and loading of waypoints.

Definition in file waypoint_sl.cpp.

## Function Documentation

## ◆ MoveWaypointsToBaseStations()

void MoveWaypointsToBaseStations | ( |  | ) |

Perform all steps to upgrade from the old waypoints to the new version that uses station.

This includes some old saveload mechanics.

Definition at line 67 of file waypoint_sl.cpp.

References _m, SmallVector< T, S >::Begin(), SmallVector< T, S >::End(), IsSavegameVersionBefore(), and Tile::m2.

## ◆ UpdateWaypointOrder()

static void UpdateWaypointOrder | ( | Order * | o | ) |
| static

Update the waypoint orders to get the new waypoint ID.

Parameters

  o | the order 'list' to check.

Definition at line 51 of file waypoint_sl.cpp.

References Order::IsType().

## Variable Documentation

## ◆ _old_waypoint_desc

const SaveLoad _old_waypoint_desc[]
| static

Initial value:
= {
SLE_CONDVAR(OldWaypoint, xy, SLE_FILE_U16 | SLE_VAR_U32, 0, 5),
SLE_CONDVAR(OldWaypoint, xy, SLE_UINT32, 6, SL_MAX_VERSION),
SLE_CONDVAR(OldWaypoint, town_index, SLE_UINT16, 12, 121),
SLE_CONDREF(OldWaypoint, town, REF_TOWN, 122, SL_MAX_VERSION),
SLE_CONDVAR(OldWaypoint, town_cn, SLE_FILE_U8 | SLE_VAR_U16, 12, 88),
SLE_CONDVAR(OldWaypoint, town_cn, SLE_UINT16, 89, SL_MAX_VERSION),
SLE_CONDVAR(OldWaypoint, string_id, SLE_STRINGID, 0, 83),
SLE_CONDSTR(OldWaypoint, name, SLE_STR, 0, 84, SL_MAX_VERSION),
SLE_VAR(OldWaypoint, delete_ctr, SLE_UINT8),
SLE_CONDVAR(OldWaypoint, build_date, SLE_FILE_U16 | SLE_VAR_I32, 3, 30),
SLE_CONDVAR(OldWaypoint, build_date, SLE_INT32, 31, SL_MAX_VERSION),
SLE_CONDVAR(OldWaypoint, localidx, SLE_UINT8, 3, SL_MAX_VERSION),
SLE_CONDVAR(OldWaypoint, grfid, SLE_UINT32, 17, SL_MAX_VERSION),
SLE_CONDVAR(OldWaypoint, owner, SLE_UINT8, 101, SL_MAX_VERSION),
}
SLE_CONDSTR
#define SLE_CONDSTR(base, variable, type, length, from, to)
Storage of a string in some savegame versions.
Definition: saveload.h:278
SLE_CONDREF
#define SLE_CONDREF(base, variable, type, from, to)
Storage of a reference in some savegame versions.
Definition: saveload.h:256
REF_TOWN
Load/save a reference to a town.
Definition: saveload.h:84
OldWaypoint
Helper structure to convert from the old waypoint system.
Definition: waypoint_sl.cpp:26
SLE_CONDVAR
#define SLE_CONDVAR(base, variable, type, from, to)
Storage of a variable in some savegame versions.
Definition: saveload.h:246
SL_MAX_VERSION
#define SL_MAX_VERSION
Highest possible savegame version.
Definition: saveload.h:96
Window::owner
Owner owner
The owner of the content shown in this window. Company colour is acquired from this variable...
Definition: window_gui.h:319
SLE_VAR
#define SLE_VAR(base, variable, type)
Storage of a variable in every version of a savegame.
Definition: saveload.h:296
SLE_STR
#define SLE_STR(base, variable, type, length)
Storage of a string in every savegame version.
Definition: saveload.h:322

Definition at line 152 of file waypoint_sl.cpp.

## ◆ _old_waypoints

SmallVector<OldWaypoint, 16> _old_waypoints
| static

Temporary array with old waypoints.

Definition at line 45 of file waypoint_sl.cpp.

## ◆ _waypoint_chunk_handlers

const ChunkHandler _waypoint_chunk_handlers[]

Initial value:
= {
{ 'CHKP', NULL, Load_WAYP, Ptrs_WAYP, NULL, CH_ARRAY | CH_LAST},
}
CH_LAST
Last chunk in this array.
Definition: saveload.h:104